#include <unistd.h>
#include <getopt.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#include "libfleximon.h"

#define OPTIONS "i:p:vh"

int main (int argc, char **argv)
{
  int verbose = 0;
  char ip [128] = "127.0.0.1";
  unsigned port = FM_DEFAULT_PORT;
  char answer [2048] = "(none)";
  char *query;
  int opt, value;

  opt = getopt(argc,argv,OPTIONS);
  while (opt != -1) {
    switch(opt) {
    case 'v':
      verbose = 1;
      break;
    case 'i':
      strcpy(ip,optarg);
      break;
    case 'p':
      value = atoi(optarg);
      if (value)
	port = value;
      else
	printf("Illegal port number %s, using %u.\n",optarg,port);
      break;
    case 'h':
      fprintf(stderr,"Synopsis: %s [-v] [-i ipaddress] [-p port] [query]\n"\
	      "-i IP address of the FlexMon server, default 127.0.0.1\n"\
	      "-p port of the FlexMon server, default 9000\n"\
	      "-v be verbose\n"\
	      "query, default query is LIST\n"
	      ,argv[0]);
      return 1;
    }
    opt = getopt(argc,argv,OPTIONS);
  }
  if (optind < argc)
    query = argv[optind];
  else
    query = "LIST";
  if (verbose)
    printf("Query: %s:%u \"%s\"\n",ip,port,query);
  fm_query(inet_addr(ip),port,query,answer,2048);
  printf("%s\n",answer);
  return 0;
}
